<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip
 * ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip extends AbstractStructArrayBase
{
    /**
     * The CoveredTrip
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip[]
     */
    public $CoveredTrip;
    /**
     * Constructor method for ArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip
     * @uses DgArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip::setCoveredTrip()
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip[] $coveredTrip
     */
    public function __construct(array $coveredTrip = array())
    {
        $this
            ->setCoveredTrip($coveredTrip);
    }
    /**
     * Get CoveredTrip value
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip[]|null
     */
    public function getCoveredTrip()
    {
        return $this->CoveredTrip;
    }
    /**
     * Set CoveredTrip value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip[] $coveredTrip
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip
     */
    public function setCoveredTrip(array $coveredTrip = array())
    {
        foreach ($coveredTrip as $arrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTripCoveredTripItem) {
            // validation for constraint: itemType
            if (!$arrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTripCoveredTripItem instanceof \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip) {
                throw new \InvalidArgumentException(sprintf('The CoveredTrip property can only contain items of \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip, "%s" given', is_object($arrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTripCoveredTripItem) ? get_class($arrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTripCoveredTripItem) : gettype($arrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTripCoveredTripItem)), __LINE__);
            }
        }
        $this->CoveredTrip = $coveredTrip;
        return $this;
    }
    /**
     * Add item to CoveredTrip value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip $item
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip
     */
    public function addToCoveredTrip(\dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip) {
            throw new \InvalidArgumentException(sprintf('The CoveredTrip property can only contain items of \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CoveredTrip[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CoveredTrip
     */
    public function getAttributeName()
    {
        return 'CoveredTrip';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfOTA_InsurancePlanSearchRQSearchTripInfoCoveredTrip
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
